#ifndef _BASSO_SELECTBASIS_H
#define _BASSO_SELECTBASIS_H

#include "DataTypes.h"
#include <signal.h> // For sig_atomic_t

#ifdef __cplusplus
#  define BEGIN_C_DECL extern "C" {
#  define END_C_DECL }
#else
#  define BEGIN_C_DECL
#  define END_C_DECL
#endif

BEGIN_C_DECL

/* Public variable to stop selectBasis */
extern volatile sig_atomic_t basso_stop_select_basis;

void
basso_selectBasis(const basso_bmatrix_cm *restrict A,
				  const basso_bmatrix_cm *restrict C,
				  const uint64_t k,
				  const uint64_t weight,
				  basso_bmatrix_cm **restrict Bptr,
				  basso_bmatrix_rm **restrict Xptr);

END_C_DECL

#endif /* _BASSO_SELECTBASIS_H */

