# SYNOPSIS
#
#   BASSO_CHECK_BUILTIN_POPCOUNT
#
# DESCRIPTION
#
#   Checks whether the compiler supports __builtin_popcountll() function.
#   Defines HAVE___BUILTIN_POPCOUNTLL as 1 if yes and sets the variable
#   basso_cv_func___builtin_popcountll to yes. 

#serial 2

AC_DEFUN([BASSO_CHECK_BUILTIN_POPCOUNT],
[AC_ARG_WITH([builtin_popcount],
	[AS_HELP_STRING([--without-builtin-popcout],
		[do not use the built-in popcount command])],
	[],
	[with_builtin_popcount=auto])
if test "x$with_builtin_popcount" != xno; then
  AC_CACHE_CHECK([does compiler support __builtin_popcountll],
  		 [basso_cv_func___builtin_popcountll],
	         [AC_COMPILE_IFELSE([AC_LANG_PROGRAM([], 
                 [unsigned long long x = __builtin_popcountll(0);
                  return x;])], 
	         [basso_cv_func___builtin_popcountll=yes],
	         [basso_cv_func___builtin_popcountll=no])])
  if test $basso_cv_func___builtin_popcountll = yes; then
    AC_DEFINE(HAVE___BUILTIN_POPCOUNTLL, 1, [Define as 1 if compiler supports __builtin_popcountll])
  fi
fi
])
