# SYNOPSIS
#
#   BASSO_CHECK_MXISSCALAR
#
# DESCRIPTION
#
#   Tests if the function mxIsScalar() is defined in "matrix.h" for the mex compiler and defines HAVE_MXISSCALAR if
#   so. Requires BASSO_CHECK_MEX to be run first.

#serial 1

AC_DEFUN([BASSO_CHECK_MXISSCALAR],
[if test "x$with_matlab" = "xyes"
then
  AC_CACHE_CHECK([for mxIsScalar], [basso_cv_mxisscalar],
    [basso_cv_mxisscalar=no
      AC_LANG_PUSH([C])
      AC_LANG_CONFTEST([AC_LANG_SOURCE([[
#include "mex.h"
#include "matrix.h"
#ifndef HAVE__BOOL
choke me
#endif
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	nlhs = (int)(mxIsScalar)(prhs[0]);
/*
	_Bool (*p)(const mxArray *) = mxIsScalar;
	plhs[0] = (mxArray *)p;
*/
}
      ]])])
      cat conftest.c > ~/Desktop/mexkoe.c
      if $MEXC CFLAGS="\$CFLAGS $MEXCFLAGS" -output conftest conftest.c 2>/dev/null 1>&2
      then
        basso_cv_mxisscalar=yes
      fi
      AC_LANG_POP([C])
  ])
  if test "x$basso_cv_mxisscalar" = xyes
  then
    AC_DEFINE([HAVE_MXISSCALAR], [1], [Define if matrix.h has mxIsScalar() under mex.])
  fi
fi
])
