/*
 * This file cannot be named basso.c, since otherwise
 * problems with the mex-file for basso will occur.
 */

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include "basso_commons.h"
#include "BasicMatrixOperations.h"
#include "MemoryManagement.h"
#include "../../include/basso.h"

int
basso(const basso_bmatrix_rm *restrict A,
      const uint64_t rank,
      const double threshold,
      const uint64_t weight,
      basso_bmatrix_cm **restrict B,
      basso_bmatrix_rm **restrict C)
{
	basso_bmatrix_rm *assoMat_row = basso_associationMatrix(A, threshold);

	const basso_bmatrix_cm *restrict Acol = colWiseMatrixFromRowWiseMatrix(A);
	const basso_bmatrix_cm *restrict assoMat_col = colWiseMatrixFromRowWiseMatrix(assoMat_row);
	freeBitMatRowWise((basso_bmatrix_rm *)assoMat_row);

	basso_selectBasis(Acol, assoMat_col, rank, weight, B, C);

	freeBitMatColWise((basso_bmatrix_cm *)Acol);
	freeBitMatColWise((basso_bmatrix_cm *)assoMat_col);

	return 0;
}

