#ifndef _BASSO_COMMONS_H
#define _BASSO_COMMONS_H

#ifdef HAVE_CONFIG_H
# include "config.h" // Configure scripts
#endif

/* uint64_t is needed by everybody */
#ifdef HAVE_INTTYPES_H
# include <inttypes.h>
#endif

/* Define POPCNT64 */
#if defined HAVE_NMMINTRIN_H
# include <nmmintrin.h>
# define POPCNT64(x) _mm_popcnt_u64(x)
#elif defined HAVE_X86INTRIN_H
# include <x86intrin.h>
# define POPCNT64(x) _mm_popcnt_u64(x)
#elif defined HAVE_INTRIN_H
# include <intrin.h>
# define POPCNT64(x) _mm_popcnt_u64(x)
#elif defined HAVE___BUILTIN_POPCOUNTLL
# define POPCNT64(x) __builtin_popcountll(x)
#else
# error "Could not define any function for 64-bit popcount"
#endif /* No support for ARM or PowerPC */

static const uint64_t ONE = 1;

#endif /* not defined _BASSO_COMMONS_H */
