#include <errno.h>
#include <string.h>
#include <stdio.h>

#include "mex.h"
#include "matrix.h" // from Matlab

#include "MatlabMemoryManagement.h"

/**
 * Returns zeroed allocated memory for a matlabMatrix with numberOfElements entries.
 */
mxLogical*
checkedCallocMatlabMat(const size_t numberOfElements)
{
  mxLogical* matlabMat;

  errno = 0;
  matlabMat = (mxLogical *)mxCalloc(numberOfElements, sizeof(mxLogical));

	if (matlabMat == NULL) {
    char errMsg[1024];
    snprintf(errMsg, 1024, "Failed to allocate space for a matrix of %zu elements:\n"
             "%s", numberOfElements, strerror(errno));
		mexErrMsgTxt(errMsg);
	}
	
	return matlabMat;
}

